'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = promiseToBluebird;
function promiseToBluebird(_ref) {
	var t = _ref.types;

	return {
		visitor: {
			ReferencedIdentifier: function ReferencedIdentifier(path, state) {
				var node = path.node;
				var parent = path.parent;
				var scope = path.scope;


				if (node.name !== 'Promise') return;
				if (t.isMemberExpression(parent)) return;
				if (scope.getBindingIdentifier(node.name)) return;

				path.replaceWith(state.addImport('bluebird', 'default', node.name));
			},


			MemberExpression: {
				exit: function exit(path, state) {
					var node = path.node;

					var obj = node.object;

					if (obj.name !== 'Promise') return;
					if (!path.isReferenced()) return;
					if (path.scope.getBindingIdentifier(obj.name)) return;

					path.replaceWith(t.memberExpression(state.addImport('bluebird', 'default', obj.name), node.property, node.computed));
				}
			}
		}
	};
}

